UVa 257 - Palinwords

题目:判断一个字符串内是否存在两个以上互不为子串的回文串(3个字符以上)。

分析:枚举。直接枚举3-4个字符的回文串即可。

说明:╮(╯▽╰)╭。

#include <algorithm>
#include <iostream>
#include <cstdlib>
#include <cstring>
#include <cstdio>
#include <cmath>

using namespace std;

bool list[457000];
char buf[260],save[260];

int value(char *str, int n)
{
	int sum = 0;
	for (int i = 0; i < n; ++ i)
		sum = sum*26+str[i]-'A';
	return sum;
}

int main()
{
	while (~scanf("%s",save)) {
		memset(list, 0, sizeof(list));
		int count = 0,list_value = 0;
		for (int i = strlen(save)-3; i >= 0 ; -- i) {
			list_value = value(save+i, 3);
			if (save[i] == save[i+2] && !list[list_value]) {
				list[list_value] = true;
				count ++;
			}
		}
		for (int i = strlen(save)-4; i >= 0 ; -- i) {
			list_value = value(save+i, 4);
			if (save[i] == save[i+3] && save[i+1] == save[i+2] &&
					!list[list_value]) {
				list[list_value] = true;
				count ++;
			}
		}
		if (count > 1) printf("%s\n",save);
	}
    return 0;
}
时间: 2024-11-12 06:37:56

UVa 257 - Palinwords的相关文章

UVA 257 - Palinwords(字符串HASH)

UVA 257 - Palinwords 题目链接 题意:输出一个文本里面的palinword,palinword的定义为,包含两个不同的回文子串,并且要求回文子串不能互相包含 思路:对于每个单词判断一次,由于不能互相包含,对于每个位置,其实就只要找长度3和4的情况即可,这样复杂度为O(n),至于判断重复的,就用hash即可 代码: #include <cstdio> #include <cstring> char str[260]; int hash[555555], save[

UVa 257 Palinword

方法:Hash 一定要好好读题,原题的要求即让你判断一个string时候有两个长度大于3的回文substring,这两个substring可以相交但是不能包含另一方. 一个很重要的observation是我们只需要找长度为3 或者长度为4的回文substring即可(贪心),可以证明, 找长度更长的回文substring效果不会比找长度为3或4的效果更好.(因为更长的回文中心总包含了一个长度为3或4的短回文substring,用这些短回文代替长回文,并不会增加被另一方包涵的回文,证明完毕).而且

uva 704

自己之前的不见了.. 这题是双向广搜即可过.. 1 // Colour Hash (色彩缤纷游戏) 2 // PC/UVa IDs: 110807/704, Popularity: B, Success rate: average Level: 3 3 // Verdict: Accepted 4 // Submission Date: 2011-08-28 5 // UVa Run Time: 0.048s 6 // 7 // 版权所有(C)2011,邱秋.metaphysis # yeah

UVA 11038 - How Many O&#39;s? 计算对答案的贡献

题意: 求[n, m]之间包含0的数字的个数题解:转化为求solve(n) - solve(m-1)的前缀问题 对于求0到n的解,我们举例 n = 25789 对于8这位,让其为0对答案的贡献是 (0~257)*(0~9) 假设是 n = 25709 那么让这位为0的答案贡献是 (0~256) * (0~9) + (257)* (0~9) //meek///#include<bits/stdc++.h> #include <cstdio> #include <cmath>

Fast Matrix Operations(UVA)11992

UVA 11992 - Fast Matrix Operations 给定一个r*c(r<=20,r*c<=1e6)的矩阵,其元素都是0,现在对其子矩阵进行操作. 1 x1 y1 x2 y2 val 表示将(x1,y1,x2,y2)(x1<=x2,y1<=y2)子矩阵中的所有元素add上val: 2 x1 y1 x2 y2 val 表示将(x1,y1,x2,y2)(x1<=x2,y1<=y2)子矩阵中的所有元素set为val: 3 x1 y1 x2 y2 val 表示输

UVa 568 Just the Facts

A过去后看了一下别人的解法,发现除了打表还有一种数论的方法. 分析一下阶乘后面的0是怎么出现的呢,当然是2乘5得到的. 我们将1~N先放在一个数组里面. 从数组第一个元素开始,先统计一下N!中因子为5的个数记为count,将其除去,然后再除去count个2.这样一来的话把所有元素乘起来后就不会出现10的倍数了. 当然并不是真正的乘起来,那样的话肯定是要溢出的,因为只关心最后一位数,所以每次乘完后求10的余数即可. 我的做法是打表,因为题目里给了N <= 10000的条件限制,所以可以把1~100

UVA 562 Dividing coins --01背包的变形

01背包的变形. 先算出硬币面值的总和,然后此题变成求背包容量为V=sum/2时,能装的最多的硬币,然后将剩余的面值和它相减取一个绝对值就是最小的差值. 代码: #include <iostream> #include <cstdio> #include <cstring> #include <cmath> #include <algorithm> using namespace std; #define N 50007 int c[102],d

UVA 10341 Solve It

Problem F Solve It Input: standard input Output: standard output Time Limit: 1 second Memory Limit: 32 MB Solve the equation: p*e-x + q*sin(x) + r*cos(x) + s*tan(x) + t*x2 + u = 0 where 0 <= x <= 1. Input Input consists of multiple test cases and te

UVA 11014 - Make a Crystal(容斥原理)

UVA 11014 - Make a Crystal 题目链接 题意:给定一个NxNxN的正方体,求出最多能选几个整数点.使得随意两点PQ不会使PQO共线. 思路:利用容斥原理,设f(k)为点(x, y, z)三点都为k的倍数的点的个数(要扣掉一个原点O).那么全部点就是f(1),之后要去除掉共线的,就是扣掉f(2), f(3), f(5)..f(n).n为素数.由于这些素数中包括了合数的情况,而且这些点必定与f(1)除去这些点以外的点共线,所以扣掉.可是扣掉后会扣掉一些反复的.比方f(6)在f